﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace eight_eight
{
    class Node
    {
        #region properties

        private int[,] matrix = new int[3,3];
        private int manhatan = 0;
        private int emptyX,emptyY;
        private int gx = 0;
        private int hx = 0;

        public int Manhatan 
        {
            get { return manhatan ;}
            set { manhatan = value;}
        }

        public int EmptyX
        {
            get { return emptyX; }
            set { emptyX = value; }
        }

        public int EmptyY
        {
            get { return emptyY; }
            set { emptyY = value; }
        }

        public int Hx
        {
            get 
            {
                hx = manhatan + gx;
                return hx; 
            }
        }

        public int Gx
        {
            get { return gx; }
            set { gx = value; }
        }

        public int[,] Matrix 
        {
            get { return matrix; }
            set
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j < 3; j++)
                    {
                        matrix[i, j] = value[i, j];
                    }
                }
            }
        }

        #endregion

        public Node()
        {
            for (int i = 0; i < 3; i++)
            {
                for (int j = 0; j < 3; j++)
                {
                    matrix[i, j] = 3 * i + j + 1;
                }
            }
            matrix[2,2] = 0;
            emptyX = 2;
            emptyY = 2;
        }

        public bool[] availableMove()
        {
            bool[] temp = new bool[4];
            if (emptyX > 0)
                temp[0] = true;
            else
                temp[0] = false;
            if (emptyX < 2)
                temp[1] = true;
            else
                temp[1] = false;
            if (emptyY < 2)
                temp[2] = true;
            else
                temp[2] = false;
            if (emptyY > 0)
                temp[3] = true;
            else
                 temp[3] = false;
             return temp;
        }

        public bool[] availableMoveCell(int cell)
        { 
            int cellX =-1, cellY=-1;
            bool[] temp = new bool[4];
            
            for (int i = 0; i < 3; i++)
            {
                for (int j = 0; j < 3; j++)
                {
                    if (matrix[i,j] == cell)
                    {
                        cellX = i;
                        cellY = j;
                    }
                }
            }

            if ((cellX - 1 == emptyX) && (cellY == emptyY))
            {
                //******** top ********
                temp[0] = true;
            }
            if ((cellX + 1 == emptyX) && (cellY == emptyY))
            {
                //******* down ********
                temp[1] = true;
            }
            if ((cellX == emptyX) && (cellY + 1 == emptyY))
            {
                //******* right ********
                temp[2] = true;
            }
           
            if ((cellX == emptyX) && (cellY - 1 == emptyY))
            {
                //******* left ********
                temp[3] = true;
            }
            return temp;
        }

        public void changeMatrixCell(int cellNum)
        { 
            int cellX = -1, cellY = -1;
            for (int i = 0; i < 3; i++)
            {
                for (int j = 0; j < 3; j++)
                {
                    if (matrix[i, j] == cellNum)
                    {
                        cellX = i;
                        cellY = j;
                    }
                }
            }
            matrix[emptyX, emptyY] = cellNum;
            emptyX = cellX;
            emptyY = cellY;
            matrix[emptyX, emptyY] = 0;
        }

        private bool test()
        {
            bool check = true; 
            for (int i = 0; i < 3; i++)
                for (int j = 0; j < 3; j++)
                {
                    if (matrix[i,j] != 3 * i + j + 1)
                    {
                        check = false;
                         break;
                    }
                }
            return check;
        }

        private void findEmpty()
        {
            for (int i = 0; i < 3; i++)
                for (int j = 0; j < 3; j++)
                {
                    if (matrix[i,j] == 0)
                    {
                        emptyX = i;
                        emptyY = j;
                        break;
                    }
                }
        }

        public void randMove()
        {
            Random rnd = new Random();
            bool[] temp = new bool[4];
            int x = 0;
            for (int i = 0; i < 1000; i++)
            {
                temp = availableMove();
                while (true)
                {
                    x = rnd.Next(0, 4);
                    if (temp[x] == true && x < 4)
                    {
                        move(x);
                        break;
                    }
                }
            }
        }

        public bool  move(int side)
        { 
            if (side == 0)
            {
                if (emptyX > 0)
                {
                    matrix[emptyX, emptyY] = matrix[emptyX - 1, emptyY];
                    matrix[emptyX - 1, emptyY] = 0;
                    emptyX--;
                    return true;
                }
                else
                    return false;
            }
            else if ( side == 1)
            {
                if (emptyX < 2)
                {
                    this.matrix[emptyX, emptyY] = this.matrix[emptyX + 1, emptyY];
                    this.matrix[emptyX + 1, emptyY] = 0;
                    emptyX++;
                    return true;
                }
                else
                    return false;
            }
            else if (side == 2)
            {if (emptyY < 2)
                {
                    this.matrix[emptyX, emptyY] = this.matrix[emptyX, emptyY + 1];
                    this.matrix[emptyX, emptyY + 1] = 0;
                    emptyY++;
                    return true;
                }
                else
                    return false;
            }
            else if (side == 3)
            {
                if (emptyY > 0)
                {
                    this.matrix[emptyX, emptyY] = this.matrix[emptyX, emptyY - 1];
                    this.matrix[emptyX, emptyY - 1] = 0;
                    emptyY--;
                    return true;
                }
                else
                    return false;
            }
            return false;
        }

        private void calculateManhatan()
        {
            int digit = 0;
            manhatan = 0;
            for (int i = 0; i < 3; i++)
            {
                for (int j = 0; j < 3; j++)
                {
                    digit = matrix[i, j];
                    if (digit != 0)
                    {
                        digit--;
                        manhatan += calculate(i, j, digit);
                    }
                }
            }
        }

        private int calculate(int x,int y,int digit)
        {
            int xTemp, yTemp;
            xTemp = digit / 3;
            yTemp = digit % 3;
            return (Math.Abs(x - xTemp) + Math.Abs(y - yTemp));
        }

        public string showManhatan()
        {
            calculateManhatan();
            string temp = "";
            temp += manhatan.ToString();
            return temp;
        }

        public int showManhatanInt()
        {
            calculateManhatan();
            string temp = "";
            temp += manhatan.ToString();
            return Convert.ToInt16(temp);
        }

        public int getEmptyX()
        {
            return emptyX;
        }

        public int getEmptyY()
        {
            return emptyY;
        }

        public void importQueueObject(queueObject obj)
        {
            matrix = obj.Matrix;
            manhatan=obj.Manhatan;
            emptyX=obj.EmptyX;
            emptyY=obj.EmptyY;
        }

    }
}